> ## Documentation Index
> Fetch the complete documentation index at: https://docs.flexprice.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Query wallet transactions

> Use when searching or reporting on wallet transactions (e.g. cross-wallet history or reconciliation). Returns a paginated list; supports filtering by wallet, customer, type, date range.



## OpenAPI

````yaml /api-reference/openapi.json post /wallets/transactions/search
openapi: 3.0.1
info:
  title: Flexprice API
  description: Flexprice API Service
  contact:
    name: API Support
  license:
    name: AGPL-3.0
    url: https://www.gnu.org/licenses/agpl-3.0.html
  version: '1.0'
servers:
  - url: https://us.api.flexprice.io/v1
    description: US Region
  - url: https://api.cloud.flexprice.io/v1
    description: India Region
security: []
paths:
  /wallets/transactions/search:
    post:
      tags:
        - Wallets
      summary: Query wallet transactions
      description: >-
        Use when searching or reporting on wallet transactions (e.g.
        cross-wallet history or reconciliation). Returns a paginated list;
        supports filtering by wallet, customer, type, date range.
      operationId: queryWalletTransaction
      requestBody:
        description: Filter
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/types.WalletTransactionFilter'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListWalletTransactionsResponse'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/errors.ErrorResponse'
        '500':
          description: Server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/errors.ErrorResponse'
      security:
        - ApiKeyAuth: []
components:
  schemas:
    types.WalletTransactionFilter:
      type: object
      properties:
        created_by:
          type: string
        credits_available_gt:
          type: number
        end_time:
          type: string
          format: date-time
        expand:
          type: string
        expiry_date_after:
          type: string
        expiry_date_before:
          type: string
        filters:
          type: array
          description: filters allows complex filtering based on multiple fields
          items:
            $ref: '#/components/schemas/types.FilterCondition'
        id:
          type: string
        limit:
          maximum: 1000
          minimum: 1
          type: integer
        offset:
          minimum: 0
          type: integer
        order:
          type: string
          enum:
            - asc
            - desc
        priority:
          type: integer
        reference_id:
          type: string
        reference_type:
          type: string
        sort:
          type: array
          items:
            $ref: '#/components/schemas/types.SortCondition'
        start_time:
          type: string
          format: date-time
        status:
          $ref: '#/components/schemas/types.Status'
        transaction_reason:
          $ref: '#/components/schemas/types.TransactionReason'
        transaction_status:
          $ref: '#/components/schemas/types.TransactionStatus'
        type:
          $ref: '#/components/schemas/types.TransactionType'
      x-speakeasy-name-override: WalletTransactionFilter
    ListWalletTransactionsResponse:
      type: object
      properties:
        items:
          type: array
          items:
            $ref: '#/components/schemas/WalletTransactionResponse'
        pagination:
          $ref: '#/components/schemas/types.PaginationResponse'
    errors.ErrorResponse:
      type: object
      properties:
        code:
          type: string
          enum:
            - not_found
            - already_exists
            - version_conflict
            - validation_error
            - invalid_operation
            - permission_denied
            - http_client_error
            - database_error
            - system_error
            - internal_error
            - service_unavailable
        details:
          type: object
          additionalProperties:
            type: object
        http_status_code:
          type: integer
        message:
          type: string
      x-speakeasy-name-override: ErrorResponse
    types.FilterCondition:
      type: object
      properties:
        data_type:
          $ref: '#/components/schemas/types.DataType'
        field:
          type: string
        operator:
          $ref: '#/components/schemas/types.FilterOperatorType'
        value:
          $ref: '#/components/schemas/types.Value'
      x-speakeasy-name-override: FilterCondition
    types.SortCondition:
      type: object
      properties:
        direction:
          $ref: '#/components/schemas/types.SortDirection'
        field:
          type: string
      x-speakeasy-name-override: SortCondition
    types.Status:
      type: string
      enum:
        - published
        - deleted
        - archived
      x-enum-varnames:
        - StatusPublished
        - StatusDeleted
        - StatusArchived
      x-speakeasy-name-override: Status
    types.TransactionReason:
      type: string
      enum:
        - INVOICE_PAYMENT
        - FREE_CREDIT_GRANT
        - SUBSCRIPTION_CREDIT_GRANT
        - PURCHASED_CREDIT_INVOICED
        - PURCHASED_CREDIT_DIRECT
        - CREDIT_NOTE
        - CREDIT_EXPIRED
        - WALLET_TERMINATION
        - MANUAL_BALANCE_DEBIT
        - CREDIT_ADJUSTMENT
        - INVOICE_VOID_REFUND
      x-enum-varnames:
        - TransactionReasonInvoicePayment
        - TransactionReasonFreeCredit
        - TransactionReasonSubscriptionCredit
        - TransactionReasonPurchasedCreditInvoiced
        - TransactionReasonPurchasedCreditDirect
        - TransactionReasonCreditNote
        - TransactionReasonCreditExpired
        - TransactionReasonWalletTermination
        - TransactionReasonManualBalanceDebit
        - TransactionReasonCreditAdjustment
        - TransactionReasonInvoiceVoidRefund
      x-speakeasy-name-override: TransactionReason
    types.TransactionStatus:
      type: string
      enum:
        - pending
        - completed
        - failed
      x-enum-varnames:
        - TransactionStatusPending
        - TransactionStatusCompleted
        - TransactionStatusFailed
      x-speakeasy-name-override: TransactionStatus
    types.TransactionType:
      type: string
      enum:
        - credit
        - debit
      x-enum-varnames:
        - TransactionTypeCredit
        - TransactionTypeDebit
      x-speakeasy-name-override: TransactionType
    WalletTransactionResponse:
      type: object
      properties:
        amount:
          type: string
        conversion_rate:
          type: string
          description: >-
            conversion_rate is the conversion rate for the transaction to the
            currency
        created_at:
          type: string
          format: date-time
        created_by:
          type: string
        created_by_user:
          $ref: '#/components/schemas/UserResponse'
        credit_amount:
          type: string
        credit_balance_after:
          type: string
        credit_balance_before:
          type: string
        credits_available:
          type: string
        currency:
          type: string
        customer:
          $ref: '#/components/schemas/CustomerResponse'
        customer_id:
          type: string
        description:
          type: string
        environment_id:
          type: string
        expiry_date:
          type: string
          format: date-time
        id:
          type: string
        idempotency_key:
          type: string
        metadata:
          $ref: '#/components/schemas/types.Metadata'
        priority:
          type: integer
        reference_id:
          type: string
        reference_type:
          $ref: '#/components/schemas/types.WalletTxReferenceType'
        status:
          $ref: '#/components/schemas/types.Status'
        tenant_id:
          type: string
        topup_conversion_rate:
          type: string
          description: >-
            topup_conversion_rate is the conversion rate for the topup to the
            currency
        transaction_reason:
          $ref: '#/components/schemas/types.TransactionReason'
        transaction_status:
          $ref: '#/components/schemas/types.TransactionStatus'
        type:
          $ref: '#/components/schemas/types.TransactionType'
        updated_at:
          type: string
          format: date-time
        updated_by:
          type: string
        wallet:
          $ref: '#/components/schemas/WalletResponse'
        wallet_id:
          type: string
    types.PaginationResponse:
      type: object
      properties:
        limit:
          type: integer
        offset:
          type: integer
        total:
          type: integer
      x-speakeasy-name-override: PaginationResponse
    types.DataType:
      type: string
      enum:
        - string
        - number
        - date
        - array
      x-enum-varnames:
        - DataTypeString
        - DataTypeNumber
        - DataTypeDate
        - DataTypeArray
      x-speakeasy-name-override: DataType
    types.FilterOperatorType:
      type: string
      enum:
        - eq
        - contains
        - not_contains
        - gt
        - lt
        - in
        - not_in
        - before
        - after
      x-enum-varnames:
        - EQUAL
        - CONTAINS
        - NOT_CONTAINS
        - GREATER_THAN
        - LESS_THAN
        - IN
        - NOT_IN
        - BEFORE
        - AFTER
      x-speakeasy-name-override: FilterOperatorType
    types.Value:
      type: object
      properties:
        array:
          type: array
          items:
            type: string
        boolean:
          type: boolean
        date:
          type: string
        number:
          type: number
        string:
          type: string
      x-speakeasy-name-override: Value
    types.SortDirection:
      type: string
      enum:
        - asc
        - desc
      x-enum-varnames:
        - SortDirectionAsc
        - SortDirectionDesc
      x-speakeasy-name-override: SortDirection
    UserResponse:
      type: object
      properties:
        email:
          type: string
          description: Empty for service accounts
        id:
          type: string
        roles:
          type: array
          items:
            type: string
        tenant:
          $ref: '#/components/schemas/TenantResponse'
        type:
          $ref: '#/components/schemas/types.UserType'
    CustomerResponse:
      type: object
      properties:
        address_city:
          type: string
          description: AddressCity is the city of the customer's address
        address_country:
          type: string
          description: >-
            AddressCountry is the country of the customer's address (ISO 3166-1
            alpha-2)
        address_line1:
          type: string
          description: AddressLine1 is the first line of the customer's address
        address_line2:
          type: string
          description: AddressLine2 is the second line of the customer's address
        address_postal_code:
          type: string
          description: AddressPostalCode is the postal code of the customer's address
        address_state:
          type: string
          description: AddressState is the state of the customer's address
        created_at:
          type: string
          format: date-time
        created_by:
          type: string
        email:
          type: string
          description: Email is the email of the customer
        environment_id:
          type: string
          description: EnvironmentID is the environment identifier for the customer
        external_id:
          type: string
          description: ExternalID is the external identifier for the customer
        id:
          type: string
          description: ID is the unique identifier for the customer
        integrations:
          type: array
          items:
            $ref: '#/components/schemas/EntityIntegrationMappingResponse'
        metadata:
          type: object
          additionalProperties:
            type: string
          description: Metadata
        name:
          type: string
          description: Name is the name of the customer
        status:
          $ref: '#/components/schemas/types.Status'
        tenant_id:
          type: string
        updated_at:
          type: string
          format: date-time
        updated_by:
          type: string
      description: Customer response object containing all customer information
    types.Metadata:
      type: object
      additionalProperties:
        type: string
      x-speakeasy-name-override: Metadata
    types.WalletTxReferenceType:
      type: string
      enum:
        - PAYMENT
        - EXTERNAL
        - REQUEST
        - INVOICE
      x-enum-varnames:
        - WalletTxReferenceTypePayment
        - WalletTxReferenceTypeExternal
        - WalletTxReferenceTypeRequest
        - WalletTxReferenceTypeInvoice
      x-speakeasy-name-override: WalletTxReferenceType
    WalletResponse:
      type: object
      properties:
        alert_settings:
          $ref: '#/components/schemas/types.AlertSettings'
        alert_state:
          $ref: '#/components/schemas/types.AlertState'
        auto_topup:
          $ref: '#/components/schemas/types.AutoTopup'
        balance:
          type: string
        config:
          $ref: '#/components/schemas/types.WalletConfig'
        conversion_rate:
          type: string
          description: |-
            amount in the currency =  number of credits * conversion_rate
            ex if conversion_rate is 1, then 1 USD = 1 credit
            ex if conversion_rate is 2, then 1 USD = 0.5 credits
            ex if conversion_rate is 0.5, then 1 USD = 2 credits
        created_at:
          type: string
          format: date-time
        created_by:
          type: string
        credit_balance:
          type: string
        credits_available_breakdown:
          $ref: '#/components/schemas/types.CreditBreakdown'
        currency:
          type: string
        customer_id:
          type: string
        description:
          type: string
        environment_id:
          type: string
        id:
          type: string
        metadata:
          $ref: '#/components/schemas/types.Metadata'
        name:
          type: string
        status:
          $ref: '#/components/schemas/types.Status'
        tenant_id:
          type: string
        topup_conversion_rate:
          type: string
          description: >-
            topup_conversion_rate is the conversion rate for the topup to the
            currency

            ex if topup_conversion_rate is 1, then 1 USD = 1 credit

            ex if topup_conversion_rate is 2, then 1 USD = 0.5 credits

            ex if topup_conversion_rate is 0.5, then 1 USD = 2 credits
        updated_at:
          type: string
          format: date-time
        updated_by:
          type: string
        wallet_status:
          $ref: '#/components/schemas/types.WalletStatus'
        wallet_type:
          $ref: '#/components/schemas/types.WalletType'
    TenantResponse:
      type: object
      properties:
        billing_details:
          $ref: '#/components/schemas/TenantBillingDetails'
        created_at:
          type: string
          format: date-time
        id:
          type: string
        metadata:
          $ref: '#/components/schemas/types.Metadata'
        name:
          type: string
        status:
          type: string
        updated_at:
          type: string
          format: date-time
    types.UserType:
      type: string
      enum:
        - user
        - service_account
      x-enum-varnames:
        - UserTypeUser
        - UserTypeServiceAccount
      x-speakeasy-name-override: UserType
    EntityIntegrationMappingResponse:
      type: object
      properties:
        created_at:
          type: string
          format: date-time
        created_by:
          type: string
        entity_id:
          type: string
        entity_type:
          $ref: '#/components/schemas/types.IntegrationEntityType'
        environment_id:
          type: string
        id:
          type: string
        provider_entity_id:
          type: string
        provider_type:
          type: string
        status:
          $ref: '#/components/schemas/types.Status'
        tenant_id:
          type: string
        updated_at:
          type: string
          format: date-time
        updated_by:
          type: string
    types.AlertSettings:
      type: object
      properties:
        alert_enabled:
          type: boolean
        critical:
          $ref: '#/components/schemas/types.AlertThreshold'
        info:
          $ref: '#/components/schemas/types.AlertThreshold'
        warning:
          $ref: '#/components/schemas/types.AlertThreshold'
      x-speakeasy-name-override: AlertSettings
    types.AlertState:
      type: string
      enum:
        - ok
        - info
        - warning
        - in_alarm
      x-enum-varnames:
        - AlertStateOk
        - AlertStateInfo
        - AlertStateWarning
        - AlertStateInAlarm
      x-speakeasy-name-override: AlertState
    types.AutoTopup:
      type: object
      properties:
        amount:
          type: number
        enabled:
          type: boolean
        invoicing:
          type: boolean
        threshold:
          type: number
      x-speakeasy-name-override: AutoTopup
    types.WalletConfig:
      type: object
      properties:
        allowed_price_types:
          type: array
          description: >-
            AllowedPriceTypes is a list of price types that are allowed for the
            wallet

            nil means all price types are allowed
          items:
            $ref: '#/components/schemas/types.WalletConfigPriceType'
      x-speakeasy-name-override: WalletConfig
    types.CreditBreakdown:
      type: object
      properties:
        free:
          type: string
        purchased:
          type: string
      x-speakeasy-name-override: CreditBreakdown
    types.WalletStatus:
      type: string
      enum:
        - active
        - frozen
        - closed
      x-enum-varnames:
        - WalletStatusActive
        - WalletStatusFrozen
        - WalletStatusClosed
      x-speakeasy-name-override: WalletStatus
    types.WalletType:
      type: string
      enum:
        - PRE_PAID
        - POST_PAID
      x-enum-varnames:
        - WalletTypePrePaid
        - WalletTypePostPaid
      x-speakeasy-name-override: WalletType
    TenantBillingDetails:
      type: object
      properties:
        address:
          $ref: '#/components/schemas/Address'
        email:
          type: string
        help_email:
          type: string
        phone:
          type: string
    types.IntegrationEntityType:
      type: string
      enum:
        - customer
        - plan
        - invoice
        - subscription
        - payment
        - credit_note
        - addon
        - item
        - item_price
        - price
      x-enum-varnames:
        - IntegrationEntityTypeCustomer
        - IntegrationEntityTypePlan
        - IntegrationEntityTypeInvoice
        - IntegrationEntityTypeSubscription
        - IntegrationEntityTypePayment
        - IntegrationEntityTypeCreditNote
        - IntegrationEntityTypeAddon
        - IntegrationEntityTypeItem
        - IntegrationEntityTypeItemPrice
        - IntegrationEntityTypePrice
      x-speakeasy-name-override: IntegrationEntityType
    types.AlertThreshold:
      type: object
      properties:
        condition:
          $ref: '#/components/schemas/types.AlertCondition'
        threshold:
          type: number
      x-speakeasy-name-override: AlertThreshold
    types.WalletConfigPriceType:
      type: string
      enum:
        - ALL
        - USAGE
        - FIXED
      x-enum-varnames:
        - WalletConfigPriceTypeAll
        - WalletConfigPriceTypeUsage
        - WalletConfigPriceTypeFixed
      x-speakeasy-name-override: WalletConfigPriceType
    Address:
      type: object
      properties:
        address_city:
          maxLength: 100
          type: string
        address_country:
          type: string
        address_line1:
          maxLength: 255
          type: string
        address_line2:
          maxLength: 255
          type: string
        address_postal_code:
          maxLength: 20
          type: string
        address_state:
          maxLength: 100
          type: string
    types.AlertCondition:
      type: string
      enum:
        - above
        - below
      x-enum-varnames:
        - AlertConditionAbove
        - AlertConditionBelow
      x-speakeasy-name-override: AlertCondition
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      description: Enter your API key in the format *x-api-key &lt;api-key&gt;**
      name: x-api-key
      in: header

````